package com.ruoyi.system.domain.visit.dr;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class VisitDrCheckHistoryFormAttachExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public VisitDrCheckHistoryFormAttachExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdIsNull() {
            addCriterion("form_type_id is null");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdIsNotNull() {
            addCriterion("form_type_id is not null");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdEqualTo(String value) {
            addCriterion("form_type_id =", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdNotEqualTo(String value) {
            addCriterion("form_type_id <>", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdGreaterThan(String value) {
            addCriterion("form_type_id >", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdGreaterThanOrEqualTo(String value) {
            addCriterion("form_type_id >=", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdLessThan(String value) {
            addCriterion("form_type_id <", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdLessThanOrEqualTo(String value) {
            addCriterion("form_type_id <=", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdLike(String value) {
            addCriterion("form_type_id like", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdNotLike(String value) {
            addCriterion("form_type_id not like", value, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdIn(List<String> values) {
            addCriterion("form_type_id in", values, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdNotIn(List<String> values) {
            addCriterion("form_type_id not in", values, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdBetween(String value1, String value2) {
            addCriterion("form_type_id between", value1, value2, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFormTypeIdNotBetween(String value1, String value2) {
            addCriterion("form_type_id not between", value1, value2, "formTypeId");
            return (Criteria) this;
        }

        public Criteria andFileNameIsNull() {
            addCriterion("file_name is null");
            return (Criteria) this;
        }

        public Criteria andFileNameIsNotNull() {
            addCriterion("file_name is not null");
            return (Criteria) this;
        }

        public Criteria andFileNameEqualTo(String value) {
            addCriterion("file_name =", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotEqualTo(String value) {
            addCriterion("file_name <>", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameGreaterThan(String value) {
            addCriterion("file_name >", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameGreaterThanOrEqualTo(String value) {
            addCriterion("file_name >=", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameLessThan(String value) {
            addCriterion("file_name <", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameLessThanOrEqualTo(String value) {
            addCriterion("file_name <=", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameLike(String value) {
            addCriterion("file_name like", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotLike(String value) {
            addCriterion("file_name not like", value, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameIn(List<String> values) {
            addCriterion("file_name in", values, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotIn(List<String> values) {
            addCriterion("file_name not in", values, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameBetween(String value1, String value2) {
            addCriterion("file_name between", value1, value2, "fileName");
            return (Criteria) this;
        }

        public Criteria andFileNameNotBetween(String value1, String value2) {
            addCriterion("file_name not between", value1, value2, "fileName");
            return (Criteria) this;
        }

        public Criteria andFilePathIsNull() {
            addCriterion("file_path is null");
            return (Criteria) this;
        }

        public Criteria andFilePathIsNotNull() {
            addCriterion("file_path is not null");
            return (Criteria) this;
        }

        public Criteria andFilePathEqualTo(String value) {
            addCriterion("file_path =", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathNotEqualTo(String value) {
            addCriterion("file_path <>", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathGreaterThan(String value) {
            addCriterion("file_path >", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathGreaterThanOrEqualTo(String value) {
            addCriterion("file_path >=", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathLessThan(String value) {
            addCriterion("file_path <", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathLessThanOrEqualTo(String value) {
            addCriterion("file_path <=", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathLike(String value) {
            addCriterion("file_path like", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathNotLike(String value) {
            addCriterion("file_path not like", value, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathIn(List<String> values) {
            addCriterion("file_path in", values, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathNotIn(List<String> values) {
            addCriterion("file_path not in", values, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathBetween(String value1, String value2) {
            addCriterion("file_path between", value1, value2, "filePath");
            return (Criteria) this;
        }

        public Criteria andFilePathNotBetween(String value1, String value2) {
            addCriterion("file_path not between", value1, value2, "filePath");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(String value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(String value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(String value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(String value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(String value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(String value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLike(String value) {
            addCriterion("create_time like", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotLike(String value) {
            addCriterion("create_time not like", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<String> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<String> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(String value1, String value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(String value1, String value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andIsValidIsNull() {
            addCriterion("is_valid is null");
            return (Criteria) this;
        }

        public Criteria andIsValidIsNotNull() {
            addCriterion("is_valid is not null");
            return (Criteria) this;
        }

        public Criteria andIsValidEqualTo(String value) {
            addCriterion("is_valid =", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotEqualTo(String value) {
            addCriterion("is_valid <>", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidGreaterThan(String value) {
            addCriterion("is_valid >", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidGreaterThanOrEqualTo(String value) {
            addCriterion("is_valid >=", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLessThan(String value) {
            addCriterion("is_valid <", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLessThanOrEqualTo(String value) {
            addCriterion("is_valid <=", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLike(String value) {
            addCriterion("is_valid like", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotLike(String value) {
            addCriterion("is_valid not like", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidIn(List<String> values) {
            addCriterion("is_valid in", values, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotIn(List<String> values) {
            addCriterion("is_valid not in", values, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidBetween(String value1, String value2) {
            addCriterion("is_valid between", value1, value2, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotBetween(String value1, String value2) {
            addCriterion("is_valid not between", value1, value2, "isValid");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIsNull() {
            addCriterion("extfield_one is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIsNotNull() {
            addCriterion("extfield_one is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneEqualTo(String value) {
            addCriterion("extfield_one =", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotEqualTo(String value) {
            addCriterion("extfield_one <>", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneGreaterThan(String value) {
            addCriterion("extfield_one >", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_one >=", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLessThan(String value) {
            addCriterion("extfield_one <", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLessThanOrEqualTo(String value) {
            addCriterion("extfield_one <=", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLike(String value) {
            addCriterion("extfield_one like", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotLike(String value) {
            addCriterion("extfield_one not like", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIn(List<String> values) {
            addCriterion("extfield_one in", values, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotIn(List<String> values) {
            addCriterion("extfield_one not in", values, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneBetween(String value1, String value2) {
            addCriterion("extfield_one between", value1, value2, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotBetween(String value1, String value2) {
            addCriterion("extfield_one not between", value1, value2, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIsNull() {
            addCriterion("extfield_two is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIsNotNull() {
            addCriterion("extfield_two is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoEqualTo(String value) {
            addCriterion("extfield_two =", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotEqualTo(String value) {
            addCriterion("extfield_two <>", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoGreaterThan(String value) {
            addCriterion("extfield_two >", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_two >=", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLessThan(String value) {
            addCriterion("extfield_two <", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLessThanOrEqualTo(String value) {
            addCriterion("extfield_two <=", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLike(String value) {
            addCriterion("extfield_two like", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotLike(String value) {
            addCriterion("extfield_two not like", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIn(List<String> values) {
            addCriterion("extfield_two in", values, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotIn(List<String> values) {
            addCriterion("extfield_two not in", values, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoBetween(String value1, String value2) {
            addCriterion("extfield_two between", value1, value2, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotBetween(String value1, String value2) {
            addCriterion("extfield_two not between", value1, value2, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIsNull() {
            addCriterion("extfield_three is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIsNotNull() {
            addCriterion("extfield_three is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeEqualTo(String value) {
            addCriterion("extfield_three =", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotEqualTo(String value) {
            addCriterion("extfield_three <>", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeGreaterThan(String value) {
            addCriterion("extfield_three >", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_three >=", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLessThan(String value) {
            addCriterion("extfield_three <", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLessThanOrEqualTo(String value) {
            addCriterion("extfield_three <=", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLike(String value) {
            addCriterion("extfield_three like", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotLike(String value) {
            addCriterion("extfield_three not like", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIn(List<String> values) {
            addCriterion("extfield_three in", values, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotIn(List<String> values) {
            addCriterion("extfield_three not in", values, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeBetween(String value1, String value2) {
            addCriterion("extfield_three between", value1, value2, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotBetween(String value1, String value2) {
            addCriterion("extfield_three not between", value1, value2, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIsNull() {
            addCriterion("extfield_four is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIsNotNull() {
            addCriterion("extfield_four is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourEqualTo(String value) {
            addCriterion("extfield_four =", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotEqualTo(String value) {
            addCriterion("extfield_four <>", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourGreaterThan(String value) {
            addCriterion("extfield_four >", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_four >=", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLessThan(String value) {
            addCriterion("extfield_four <", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLessThanOrEqualTo(String value) {
            addCriterion("extfield_four <=", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLike(String value) {
            addCriterion("extfield_four like", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotLike(String value) {
            addCriterion("extfield_four not like", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIn(List<String> values) {
            addCriterion("extfield_four in", values, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotIn(List<String> values) {
            addCriterion("extfield_four not in", values, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourBetween(String value1, String value2) {
            addCriterion("extfield_four between", value1, value2, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotBetween(String value1, String value2) {
            addCriterion("extfield_four not between", value1, value2, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIsNull() {
            addCriterion("extfield_five is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIsNotNull() {
            addCriterion("extfield_five is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveEqualTo(String value) {
            addCriterion("extfield_five =", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotEqualTo(String value) {
            addCriterion("extfield_five <>", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveGreaterThan(String value) {
            addCriterion("extfield_five >", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_five >=", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLessThan(String value) {
            addCriterion("extfield_five <", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLessThanOrEqualTo(String value) {
            addCriterion("extfield_five <=", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLike(String value) {
            addCriterion("extfield_five like", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotLike(String value) {
            addCriterion("extfield_five not like", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIn(List<String> values) {
            addCriterion("extfield_five in", values, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotIn(List<String> values) {
            addCriterion("extfield_five not in", values, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveBetween(String value1, String value2) {
            addCriterion("extfield_five between", value1, value2, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotBetween(String value1, String value2) {
            addCriterion("extfield_five not between", value1, value2, "extfieldFive");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}